"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const scannerJS = require("./js/jsqrscanner.nocache.js");
class JsQRScanner {
    constructor() {
        if (!g.JsQRScanner) {
            throw new Error('JsQRScanner is not ready yet!');
        }
        this.scanner = new g.JsQRScanner(s => this.handleScannedText(s));
    }
    handleScannedText(scannedText) {
        if (this.onQRCodeScanned) {
            this.onQRCodeScanned(scannedText);
        }
    }
}
function createJsQRScanner() {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            CallWhenQRSacannerReady(() => {
                const scanner = new JsQRScanner();
                resolve(scanner);
            });
        });
    });
}
exports.createJsQRScanner = createJsQRScanner;
const g = window;
const callbacks = [];
function CallWhenQRSacannerReady(cb) {
    if (g.JsQRScanner) {
        cb();
    }
    else {
        callbacks.push(cb);
    }
}
function JsQRScannerReady() {
    if (callbacks.length > 0) {
        callbacks.forEach(cb => cb());
        callbacks.splice(0, callbacks.length);
    }
}
if (scannerJS) {
    g.JsQRScannerReady = JsQRScannerReady;
}
//# sourceMappingURL=jsqrscanner.js.map